//+--------------------------------------------------------------------------------------------+
//|   RenkoBricks_v2.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 3
#property indicator_color1 EMPTY
#property indicator_color2 EMPTY
#property indicator_color3 EMPTY

extern int BoxSize = 100;
extern int Reversal = 2;

int i,BoxCount,Index;
double BoxPips,RevPips;
datetime StartTime;

double Hi[];
double Lo[];
double Trend[];


int init()
{
      
   IndicatorBuffers(3);

   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,Hi);
   
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,Lo);
   
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,Trend);
   
   BoxPips = NormalizeDouble(BoxSize*Point,Digits);
   RevPips = NormalizeDouble(BoxPips*Reversal,Digits);
   
   return(0);
}

int deinit()
{
   ObjectsDeleteAll();
   
   return(0);
}

int start()
{
//   barf
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   
   for (i=Bars-counted_bars;i>=0;i--)
   {
      Lo[i] = Lo[i+1];
      Hi[i] = Hi[i+1];
      Trend[i] = Trend[i+1];

      if (Trend[i] < 1)
      {
         if (High[i] > Lo[i]+RevPips || CompareDoubles(High[i],Lo[i]+RevPips))
         {
            Hi[i] = Lo[i];
            while (NormalizeDouble(Hi[i],Digits) < NormalizeDouble(High[i],Digits))
            {Hi[i] += BoxPips;}
            while (NormalizeDouble(Hi[i],Digits) > NormalizeDouble(High[i],Digits))
            {Hi[i] -= BoxPips;}
            Lo[i] = Hi[i]-BoxPips;
            Trend[i] = 1;
            Index++;
            StartTime = Time[i+1];
            DrawBox();
         }
         else
         if (Low[i] < Lo[i]-BoxPips || CompareDoubles(Low[i],Lo[i]-BoxPips))
         {
            while (NormalizeDouble(Lo[i],Digits) > NormalizeDouble(Low[i],Digits))
            {Lo[i] -= BoxPips;}
            if (NormalizeDouble(Lo[i],Digits) < NormalizeDouble(Low[i],Digits))
            {Lo[i] += BoxPips;}
            Hi[i] = Lo[i]+BoxPips;
            Index++;
            StartTime = Time[i+1];
            DrawBox();
         }
      }
      else
      if (Trend[i] > -1)
      {
         if (Low[i] < Hi[i]-RevPips || CompareDoubles(Low[i],Hi[i]-RevPips))
         {
            Lo[i] = Hi[i];
            while (NormalizeDouble(Lo[i],Digits) > NormalizeDouble(Low[i],Digits))
            {Lo[i] -= BoxPips;}
            while (NormalizeDouble(Lo[i],Digits) < NormalizeDouble(Low[i],Digits))
            {Lo[i] += BoxPips;}
            Hi[i] = Lo[i]+BoxPips;
            Trend[i] = -1;
            Index++;
            StartTime = Time[i+1];
            DrawBox();
         }
         else
         if (High[i] > Hi[i]+BoxPips || CompareDoubles(High[i],Hi[i]+BoxPips))
         {
            while (NormalizeDouble(Hi[i],Digits) < NormalizeDouble(High[i],Digits))
            {Hi[i] += BoxPips;}
            if (NormalizeDouble(Hi[i],Digits) > NormalizeDouble(High[i],Digits))
            {Hi[i] -= BoxPips;}
            Lo[i] = Hi[i]-BoxPips;
            Index++;
            StartTime = Time[i+1];
            DrawBox();
         }
      }
      DrawBox();
   }           

   return(0);

}

void DrawBox()
{
   if (ObjectFind("Box"+Index) == 1)
   {   
      ObjectSet("Box"+Index,OBJPROP_TIME2,Time[i]);
     
   }
   else
   {   
      ObjectCreate("Box"+Index,OBJ_RECTANGLE,0,0,0,0,0);
      ObjectSet("Box"+Index,OBJPROP_TIME1,StartTime);
      ObjectSet("Box"+Index,OBJPROP_PRICE1,Hi[i]);
      ObjectSet("Box"+Index,OBJPROP_TIME2,Time[i]);
      ObjectSet("Box"+Index,OBJPROP_PRICE2,Lo[i]);
      ObjectSet("Box"+Index,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Box"+Index,OBJPROP_BACK,True);
      if (Trend[i] == 1)
      {
      ObjectSet("Box"+Index,OBJPROP_COLOR,Blue);
      
      }
      else
      {
      ObjectSet("Box"+Index,OBJPROP_COLOR,Red);
      
      }
      
   }
}
//+--------------------------------------------------------------------------------------------+